char PhoneRecord[20];
char PhoneRecordTmp[17];

void ReadPhoneBook(int Page)
{// Read blocks of 8 phone numbers from phone book of granted numbers
  int AddressPtr;
  
  if(Page < 0 || Page > 7) Page = 7; //check boundaries
  strcpy(TmpStr, "#\n");
  for (int i=0; i<8; i++)
  {
    AddressPtr=i+Page*8;
    strcat(TmpStr, ReadNunmber(AddressPtr, PhoneRecord));
  }
  strcat(TmpStr, "\0");
}

char* ReadNunmber(int Pointer, char* PhoneRecord)
{// Add the address number to record read
 // The number returns in char * PhoneRecord
  char Addr[3];

  itoa(Pointer, Addr, 10);
  if(Pointer<10)
  {
    strcpy(PhoneRecord, "0");
    strcat(PhoneRecord, Addr);
  }
  else
  {
    strcpy(PhoneRecord, Addr);
  }
  strcat(PhoneRecord, "-");
  strcat(PhoneRecord, ReadRecord(Pointer, PhoneRecordTmp));
  strcat(PhoneRecord, "\n");
}

char* ReadRecord(int Pointer, char* PhoneRecordTmp)
{// Read the phone number in address book at a specific position
 // The number returns in char * PhoneRecord
  int CipherPtr;
  char Tmp[2];

  strcpy(PhoneRecordTmp, "");

  if(Pointer < 0 || Pointer > 63) Pointer = 63; //check boundaries
  for(int j=0; j<16; j++)
    {
      CipherPtr=Pointer * 16 + j;
      char Cipher = EEPROM.read(CipherPtr);
      if (Cipher)
      {
        itoa(Cipher-48, Tmp, 10);
        strcat(PhoneRecordTmp, Tmp);
      }
    }
    return PhoneRecordTmp;
}

void WriteNunmber(int Pointer, char* PhoneToWrite)
{// Write the given phone number in address book at the specific position
  int CipherPtr;

  if(Pointer < 0 || Pointer > 63) Pointer = 63; //check boundaries
  for(int j=0; j<16; j++)
  {
    CipherPtr=Pointer * 16 + j;
    if (isdigit(PhoneToWrite[j]))
    {
      EEPROM.update(CipherPtr, PhoneToWrite[j]);
      /*
      Serial.print(j);
      Serial.print(" ");
      Serial.print(CipherPtr);
      Serial.print(" ");
      Serial.println(PhoneToWrite[j]);
      */
    }
    else
    {
      EEPROM.update(CipherPtr, 0);
      /*
      Serial.print(j);
      Serial.print("+");
      Serial.print(CipherPtr);
      Serial.print("+");
      Serial.println(PhoneToWrite[j]);
      */
    }  
  }
}

void FormatEeprom(void)
{// Fill up the whole phone book with value 0
  for (int i=0; i<1024; i++)
  {
    Serial.print(i);
    Serial.print(" ");
    Serial.print(EEPROM.read(i));
    Serial.print(" ");
    EEPROM.update(i, 0);
    Serial.println(EEPROM.read(i));
  }
}

int CheckGranted(char* PhoneToCheck)
{// Compare the calling number with the phonebook
 // return the position number in phonebook if found
 // 0xFF if not found
  int Ok=0xFF;
  
  Serial.println("Checking match in Phone Book");
  for(int i=0; i<64; i++)
  {
    ReadRecord(i, PhoneRecord);
    
    if(isdigit(PhoneRecord[0]))
    {
    if(NULL == strstr(PhoneToCheck, PhoneRecord))
      {
        Ok = 0xFF; 
      }
      else
      {
        Ok = i;
        break;
      }
    }
  }
  return Ok;
}

